/*
 * khelp.c - Helper functions in kernel context
 *
 * Written 2002 by Werner Almesberger
 */


#define __KERNEL__
#include "linux/include/linux/kernel.h"
#include "linux/include/linux/sched.h"
#include "linux/include/linux/interrupt.h"

#include "khelp.h"


/*
 * got_work_without_tick is probably useless until simulation can generate
 * activity without using interupts (e.g. create a packet out of thin air, then
 * enqueue it on an interface).
 */

int got_work_without_tick(void)
{
    return !!softirq_pending(0);
    /* @@@ should check all CPUs */
}


int got_work_with_tick(void)
{
    return TQ_ACTIVE(tq_timer);
}


/*
 * Getting idle despite having work to do was briefly discussed on l-k.
 * For now, let's play it safe and explicitly get out of idle if we find any
 * other process.
 */

int other_runnable(void)
{
    struct task_struct *p;

    for_each_task(p) {
#if 0
	printk("pid %d state %ld cmd \"%16s\" (i'm %d)\n",p->pid,p->state,
	  p->comm,init_task.pid);
#endif
	if (p != current && p->state == TASK_RUNNING) return 1;
    }
    return 0;
}
