/*
 * timer.h - Event timers
 * 
 * Written 2002 by Werner Almesberger
 */


#ifndef TIMER_H
#define TIMER_H

#ifndef __KERNEL__
#include <sys/time.h>
#endif

extern struct timeval now;
extern unsigned long jiffies;

extern int use_sigalrm;
extern int dont_tick;

void wake_kernel(unsigned delta_jiffies);
void wait_kernel(void);
void set_timer(struct timeval tv,void (*fn)(void *user),void *user);
unsigned long tv2jiffies(struct timeval tv);

void umlsim_setup_time(void);

#endif /* TIMER_H */
